/**
 * Classe concreta che rappresenta i giorni italiani.
 * 
 * @author bioInfo
 */
public class GiornoIT extends Giorno {

	/**
	 * Costruisce il giorno in Italiamo corrispondente alla posizione passata come
	 * parametro.
	 * 
	 * @param posizione
	 *            posizione corrispondente al giorno.
	 */
	public GiornoIT(int posizione) {
		super(posizione);
	}

	@Override
	public Giorno seguente(int giorniTrascorsi) {
		return new GiornoIT((getPosizione() + giorniTrascorsi) % 7);
	}

	@Override
	public String toString() {
		return nome[getPosizione()];
	}

	/**
	 * campo ausiliario che memorizza i nomi dei giorni in italiano.
	 */
	private final static String[] nome = { "Domenica", "Lunedì", 
	    "Martedì", "Mercoledì", "Giovedì", "Venerdì", "Sabato" };
}
