/**
 * Classe concreta che rappresenta i giorni in inglese.
 * 
 * @author bioInfo
 */
public class GiornoUK extends Giorno {

	/**
	 * Costruisce il giorno alla posizione passata come parametro.
	 * 
	 * @param posizione
	 *            posizione del giorno nella settimana.
	 */
	public GiornoUK(int posizione) {
		super(posizione);
	}

	@Override
	public Giorno seguente(int giorniTrascorsi) {
		return new GiornoUK((getPosizione() + giorniTrascorsi) % 7);
	}

	@Override
	public String toString() {
		return nome[getPosizione()];
	}

	/**
	 * campo ausiliario che memorizza i nomi delle note italiane.
	 */
	private final static String[] nome = { "Sunday", "Monday", "Tuesday",
	        "Wednesday", "Thursday", "Friday", "Saturday" };
}
