/**
 * Classe che scrive una stringa in camel-style.
 * 
 * @author mace
 * @version 1.0
 * 
 */
public class Camelize {

	/**
	 * Metodo di test.
	 * 
	 * @param args argomenti passati da linea di comando
	 */
    public static void main(String[] args) {
        System.out.println(camelize("camels are sweet and clever animals"));
    }

	/**
	 * riceve come parametro una stringa <code>s</code> e restituisce una nuova stringa, 
	 * che è la versione <i>camel-style</i> della stringa code>s</code>,
	 * in cui cioè gli spazi sono stati eliminati e l'inizio delle parole (tranne la prima)
	 * è stato scritto in maiuscolo. 
	 * Il metodo funziona se code>s</code> contiene solo caratteri alfabetici 
	 * minuscoli e spazi, non ha mai due spazi di seguito e comincia e termina 
	 * con un carattere alfabetico minuscolo.
	 * 
	 * @param s  stringa di riferimento.
	 * @return 
	 *           la versione <i>camel-style</i> della stringa code>s</code>
	 */
	public static String camelize(String s) {
	    int i = 0;
	    String res = "";
		while (i < s.length()) {
			if ((s.charAt(i)) == ' ')
				res += s.substring(++i, i + 1).toUpperCase();
		    else
		        res += s.charAt(i);
		    i++;
	   }
	   return res;
	}
}
