/**
 * Classe che risolve il secondo esercizio dell'esame del 16 febbraio 2015.
 * 
 * @author bioInfo
 * @version 1.0
 * 
 */
public class ContaPari {

	/**
	 * Metodo test.
	 * 
	 * @param args
	 *            argomenti ricevuti da linea di comando, non sono utilizzati
	 *            dal metodo.
	 */
	public static void main(String[] args) {
		int[] vett = { 23, 45, 32, 9, 23, 8, 9, 23, 45, 8 };

        System.out.println(
            contaPari(vett, 0) + ", " +
            contaPari(vett, 3) + ", " +
            contaPari(vett, -3));
	}

	/**
	 * Dato il vettore <code>vett</code>, conta
	 * quanti sono i valori pari in <code>vett</code> dalla
	 * posizione <code>pos</code> (compresa) fino alla fine. <br>
	 * 
	 * I valori significativi per <code>pos</code> vanno da 0 all'ultima
	 * posizine del vettore (<code>vett.length - 1</code>). <br>
	 * 
	 * CASO BASE: se <code>pos > vett.length - 1</code> non abbiamo elementi da
	 * confrontare: restituiamo 0. <br>
	 * 
	 * PASSO INDUTTIVO: se <code>pos < vett.length</code>, calcoliamo il umero
	 * di pari che compaiono in <code>vett</code> dalla
	 * posizione <code>pos + 1</code> (compresa) fino alla fine dell'array.
	 * Verifichiamo se il contenuto della posizione <code>pos</pos> dell'array 
	 * sia pari e, in caso affermativo, sommiamo 1.
	 * 
	 * @param vett
	 *            vettore considerato.
	 * @param pos
	 *            posizione da cui partire.
	 * @return il numero di valori pari che compaiono in <code>vett</code> 
	 *         dalla posizione <code>pos</code> (compresa) a <code>vett.length - 1</code> 
	 *         se <code>pos</code> e' nel range degli inidici di <code>vett</code>, 
	 *         <code>0</code> altrimenti.
	 */
	private static int contaPari(int[] vett, int pos) {
		// Verifichiamo che pos possa essere l'indice di un array.
		// In questo controllo includiamo anche il caso base: sotto-array vuoto.
		if (pos < 0 || pos >= vett.length)
			return 0;

		// PRECONDIZIONE: 0 <= pos < vett.length
		if (vett[pos] % 2 == 0)
			return 1 + contaPari(vett, pos + 1);

		return contaPari(vett, pos + 1);
	}

}
